/* ---------------------------------------------------------------------
 * 
 * Giada - Your Hardcore Loopmachine 
 * 
 * ---------------------------------------------------------------------
 * 
 * Copyright (C) 2010-2012 Giovanni A. Zuliani | Monocasual
 * 
 * This file is part of Giada - Your Hardcore Loopmachine.
 * 
 * Giada - Your Hardcore Loopmachine is free software: you can 
 * redistribute it and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * Giada - Your Hardcore Loopmachine is distributed in the hope that it 
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Giada - Your Hardcore Loopmachine. If not, see 
 * <http://www.gnu.org/licenses/>.
 * 
 * ------------------------------------------------------------------ */




#ifndef GLUE_H
#define GLUE_H

#include "mixerHandler.h"
#include "gui_utils.h"
#include "ge_mixed.h"


int glue_loadChannel(int c, const char *fname, const char *fpath);
int glue_unloadChannel(int c);


int glue_loadPatch(const char *fname, const char *fpath, class gProgress *status);
int glue_savePatch(const char *fullpath, const char *name);


int glue_saveSample(int ch, const char *fullpath);



void glue_keyPress  (int c, bool ctrl=0, bool shift=0);
void glue_keyRelease(int c, bool ctrl=0, bool shift=0);

void glue_setBpm(const char *v1, const char *v2);
void glue_setBeats(int beats, int bars, bool expand);

void glue_startSeq();
void glue_stopSeq();
void glue_rewindSeq();



void glue_startRec();
void glue_stopRec();



int glue_startInputRec();
int glue_stopInputRec();



void glue_startReadingRecs(int chan);
void glue_stopReadingRecs(int chan);

void glue_quantize(int val);

void glue_setVol(int chan, float v);
void glue_setOutVol(float v);
void glue_setInVol(float v);


void glue_setPanning(class gdEditor *win, int ch, float val);

void glue_clearAllSamples();
void glue_clearAllRecs();



void glue_resetToInitState(bool resetGui=true);

void glue_startStopMetronome();




void glue_setBeginEndChannel(class gdEditor *win, int ch, int b, int e,
														 bool recalc=false, bool check=true);


void glue_setBoost(class gdEditor *win, int ch, float val, bool numeric);

void glue_setPitch(class gdEditor *win, int ch, float val, bool numeric);



 
void glue_setVolEditor(class gdEditor *win, int ch, float val, bool numeric);



void glue_writeMute(int ch, bool gui);



 
void glue_readMute(int ch, int type);




void glue_setChannelWithActions(int ch);


int glue_saveProject(const char *folderPath, const char *projName);




void glue_beatsMultiply();
void glue_beatsDivide();

#endif
