/* ---------------------------------------------------------------------
 * 
 * Giada - Your Hardcore Loopmachine 
 * 
 * ---------------------------------------------------------------------
 * 
 * Copyright (C) 2010-2012 Giovanni A. Zuliani | Monocasual
 * 
 * This file is part of Giada - Your Hardcore Loopmachine.
 * 
 * Giada - Your Hardcore Loopmachine is free software: you can 
 * redistribute it and/or modify it under the terms of the GNU General 
 * Public License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * Giada - Your Hardcore Loopmachine is distributed in the hope that it 
 * will be useful, but WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Giada - Your Hardcore Loopmachine. If not, see 
 * <http://www.gnu.org/licenses/>.
 * 
 * ------------------------------------------------------------------ */



#ifndef RECORDER_H
#define RECORDER_H

#include <stdio.h>
#include <stdlib.h>
#include "const.h"
#include "utils.h"
#include "mixer.h"



namespace recorder {

struct _action { 
	unsigned chan;
	char     type;
};

extern gVector<int>  frames;					      
extern gVector< gVector<_action*> > global;	
extern gVector<_action*>  actions;				  

extern bool active;
extern bool chanActive[MAX_NUM_CHAN];				
extern bool chanEvents[MAX_NUM_CHAN];				
extern bool sortedActions;                  


void init();


void chanHasEvents(unsigned chan);


bool canRec(int chan);


void rec(unsigned chan, char action, int frame);


void clearChan(unsigned chan);


void clearAction(unsigned chan, char action);


void deleteAction(unsigned chan, int frame, char type);


void clearAll();


void optimize();


void sortActions();


void updateBpm(float oldval, float newval, int oldquanto);


void updateSamplerate(int systemRate, int patchRate);

void expand(int old_fpb, int new_fpb);
void shrink(int new_fpb);


void enableRead(int chan);
void disableRead(int chan);


int getStartActionFrame(unsigned chan, char action, int frame);


int getEndActionFrame(unsigned chan, char action, int frame);


void print();

}  

#endif
